#ifndef I2C_H
#define I2C_H

#include <inttypes.h>
#include <avr/delay.h>

enum {
	ESTADO_I2C_REPOSO=0,
	ESTADO_I2C_LEYENDO_ACCEL,
	ESTADO_I2C_LEYENDO_MAGNETO,
	//ESTADO_I2C_LEYENDO_DISTANCIA,
	ESTADO_I2C_MUESTREO_TERMINADO,
};

enum {
	SUBESTADO_1,
	SUBESTADO_2,
	SUBESTADO_3,
	SUBESTADO_FIN,
};

enum{
	ESTADO_SENSOR_BEGIN,
	ESTADO_SENSOR_END_TRANSMISSION,
	ESTADO_SENSOR_RECEIVE,
	ESTADO_SENSOR_ESPERANDO,
	ESTADO_SENSOR_END_TRANSMISSION_2,
	ESTADO_SENSOR_FIN,
};

enum{
	ESTADO_
};

typedef struct i2c{
	int estado;
	int estado_accel;
	int estado_magneto;
	//int estado_prox;
	//uint8_t distancia;
	int x_accel;
	int y_accel;
	int z_accel;
	int x_magneto;
	int y_magneto;
	int z_magneto;
	int subestado;
}i2c;

void idosc(i2c* p_i2c);
void inicializar_subestados_i2c(i2c* p_i2c);
void Accel_Init();
void Compass_Init();
//void Prox_Init();

#endif
