/*
 * RX.cpp
 *
 *  Created on: 21/10/2010
 *      Author: mindurain
 */


#include "RX.h"
#include "Arduino/HardwareSerial.h"

int	despaquetizando(rx* p_rx);

void Rx(rx* p_rx)
{
	switch(p_rx->estado)
	{
		case ESTADO_RX_REPOSO:
		{
			if (Serial.available())
			{
				p_rx->estado=ESTADO_RX_RECIBIENDO_SERIE;
				p_rx->i=0;
			}
		}
		break;

		case ESTADO_RX_RECIBIENDO_SERIE:
		{
			if (Serial.available())
			{
				p_rx->motores[(p_rx->i)++]=Serial.read();
				if (p_rx->motores[0]=='E')
				{
					if (p_rx->i==5)
					{
						p_rx->estado=ESTADO_RX_DESPAQUETIZANDO;
					}
				}else
					{
						p_rx->estado=ESTADO_RX_REPOSO;
					}
				//Serial.write(p_rx->i);
			}
		}
		break;

		case ESTADO_RX_DESPAQUETIZANDO:
		{
			int paquete_reconocido=despaquetizando(p_rx);
			if (paquete_reconocido==1)
			{
				p_rx->estado=ESTADO_RX_VALORES_MOTORES;
			}else
				p_rx->estado=ESTADO_RX_REPOSO;
		}
		break;

		case ESTADO_RX_VALORES_MOTORES:
		{

		}
		break;
	}
}



int	despaquetizando(rx* p_rx)
{
	int sum=0;
	char checksum=0;

	if (p_rx->motores[0]=='E')
	{
		for (int i=1; i<4; i++)
		{
			sum += p_rx->motores[i];
			checksum = 0xFF - sum;
		}
		if (p_rx->motores[4]==checksum)
		{
			return 1;
		}else
			return 0;
	}else
		return 0;
}
